---------------------
PatchSet 4150 
Date: 2002/05/21 02:46:41
Author: jkay
Branch: push
Tag: (none) 
Log:

Version of push that passes 'put' test scripts
(e.g., seems to work!)

Members: 
	doc/push.txt:1.1.2.1->1.1.2.2 
	src/HintCache.c:1.1.2.1->1.1.2.2 
	src/HintCacheDisk.c:1.1.2.1->1.1.2.2 
	src/HintCacheEndian.c:1.1.2.1->1.1.2.2 
	src/HintCacheHier.c:1.1.2.1->1.1.2.2 
	src/HintCacheNet.c:1.1.2.2->1.1.2.3 
	src/HintCacheNodes.c:1.1.2.1->1.1.2.2 
	src/HintCachePrim.c:1.1.2.1->1.1.2.2 
	src/Plaxton.c:1.1.2.1->1.1.2.2 
	src/cf.data.pre:1.43.2.2->1.43.2.3 
	src/defines.h:1.15.2.2->1.15.2.3 
	src/dist.c:1.1.2.4->1.1.2.5 
	src/enums.h:1.27.2.5->1.27.2.6 
	src/globals.h:1.14.2.2->1.14.2.3 
	src/http.c:1.17.2.4->1.17.2.5 
	src/main.c:1.28.2.4->1.28.2.5 
	src/protos.h:1.41.2.5->1.41.2.6 
	src/put.c:1.1.2.5->1.1.2.6 
	src/store.c:1.16.2.1->1.16.2.2 
	src/structs.h:1.47.2.5->1.47.2.6 
	src/typedefs.h:1.25.2.4->1.25.2.5 

Index: squid/src/HintCache.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/HintCache.c,v
retrieving revision 1.1.2.1
retrieving revision 1.1.2.2
diff -u -r1.1.2.1 -r1.1.2.2
--- squid/src/HintCache.c	20 Nov 2001 06:47:11 -0000	1.1.2.1
+++ squid/src/HintCache.c	21 May 2002 02:46:41 -0000	1.1.2.2
@@ -1,8 +1,8 @@
 /*
- * $Date: 2001/11/20 06:47:11 $ $Id: HintCache.c,v 1.1.2.1 2001/11/20 06:47:11 jkay Exp $
+ * $Date: 2002/05/21 02:46:41 $ $Id: HintCache.c,v 1.1.2.2 2002/05/21 02:46:41 jkay Exp $
  *
  * AUTHOR: Mike Dahlin, UT Austin, 1998
- * DEBUG: section 54    Hint cache to Squid interface.
+ * DEBUG: section 84    Hint cache to Squid interface.
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
  * --------------------------------------------------------
@@ -39,14 +39,14 @@
 
 #include "squid.h"
 
-static EVH hintCacheTimer;   /* timeout to flush StoreEntries */
+static EVH hintCacheTimer;	/* timeout to flush StoreEntries */
 
-#define HINT_CACHE_DEBUG 54
+#define HINT_CACHE_DEBUG 84
 
 /*
  * Globals
  */
-#ifdef USE_DYNAMIC_HIERARCHY
+#if USE_DYNAMIC_HIERARCHY
 HintCacheNet *parentOutgoingA = NULL;
 HintCacheNet *childrenOutgoingA = NULL;
 HintCacheNet *neighborsOutgoing = NULL;
@@ -72,49 +72,53 @@
 int
 hintCacheInit()
 {
-  peer *e;
-#ifdef USE_DYNAMIC_HIERARCHY
-  int ii;
+    peer *e;
+#if USE_DYNAMIC_HIERARCHY
+    int ii;
 #endif
-  
-  hcDisk = (HintCacheDisk *)xmalloc(sizeof(HintCacheDisk));
-  assert(hcDisk);
-  hintCacheDiskInit(hcDisk, Config.Hints.cachefile);
-  
+
+    hcDisk = (HintCacheDisk *) xmalloc(sizeof(HintCacheDisk));
+    assert(hcDisk);
+    hintCacheDiskInit(hcDisk, Config.Hints.cache_file);
+
 #if USE_DYNAMIC_HIERARCHY
-  /*
-   * Three sets of network buffers. Children and parents
-   * are the children and parents as determined by the
-   * dynamic hierarchy algorithm (HCHier.h). Neighbors
-   * are static squid neighbors (neighbors.h). The
-   * static neighbors are used to bootstrap the
-   * dynamic algorithm.
-   */
-  neighborsOutgoing = (HintCacheNet *)xmalloc(sizeof(HintCacheNet));
-  assert(neighborsOutgoing);
-  hintCacheNetInit(neighborsOutgoing);
-  hintCacheHierInit();
-
-  childrenOutgoingA = (HintCacheNet *)xmalloc(sizeof(HintCacheNet) * hintCacheHier_NChildrenQs());
-  assert(childrenOutgoingA);
-  for(ii = 0; ii < hintCacheHierNChildrenQs(); ii++){
-    hintCacheNet_Init(&childrenOutgoingA[ii]);
-  }
-  parentOutgoingA = (HintCacheNet *)xmalloc(sizeof(HintCacheNet) * hintCacheHier_NParentQs());
-  assert(parentOutgoingA);
-  for(ii = 0; ii < hintCacheHierNParentQs(); ii++){
-    hintCacheNetInit(&parentOutgoingA[ii]);
-  }
+    /*
+     * Three sets of network buffers. Children and parents
+     * are the children and parents as determined by the
+     * dynamic hierarchy algorithm (HCHier.h). Neighbors
+     * are static squid neighbors (neighbors.h). The
+     * static neighbors are used to bootstrap the
+     * dynamic algorithm.
+     */
+    neighborsOutgoing = (HintCacheNet *) xmalloc(sizeof(HintCacheNet));
+    assert(neighborsOutgoing);
+    hintCacheNetInit(neighborsOutgoing);
+    hintCacheHierInit();
+
+    childrenOutgoingA =
+	(HintCacheNet *) xmalloc(sizeof(HintCacheNet) *
+	hintCacheHier_NChildrenQs());
+    assert(childrenOutgoingA);
+    for (ii = 0; ii < hintCacheHierNChildrenQs(); ii++) {
+	hintCacheNet_Init(&childrenOutgoingA[ii]);
+    }
+    parentOutgoingA =
+	(HintCacheNet *) xmalloc(sizeof(HintCacheNet) *
+	hintCacheHier_NParentQs());
+    assert(parentOutgoingA);
+    for (ii = 0; ii < hintCacheHierNParentQs(); ii++) {
+	hintCacheNetInit(&parentOutgoingA[ii]);
+    }
 #else
-  for (e = getFirstPeer(); e; e = getNextPeer(e))
-      hintCacheNetInit(&e->hcoutq);
+    for (e = getFirstPeer(); e; e = getNextPeer(e))
+	hintCacheNetInit(&e->hcoutq);
 #endif
 
-  /* Start hint timer */
-  eventAdd("hint timer", hintCacheTimer, NULL,
-	   (double) (squid_random() % Config.Hints.intvl), 1);
+    /* Start hint timer */
+    eventAdd("hint timer", hintCacheTimer, NULL,
+	(double) (squid_random() % Config.Hints.intvl), 1);
 
-  return 0;
+    return 0;
 }
 
 /*
@@ -138,29 +142,29 @@
 void
 hintCacheDestroy()
 {
-#ifdef USE_DYNAMIC_HIERARCHY
-  int ii;
+#if USE_DYNAMIC_HIERARCHY
+    int ii;
 
-  for(ii = 0; ii < hintCacheHier_NChildrenQs(); ii++){
-    hintCacheNetDestroy(&childrenOutgoingA[ii]);
-  }
-  xfree(childrenOutgoingA);
-  childrenOutgoingA = NULL;
-  for(ii = 0; ii < hintCacheHier_NParentQs(); ii++){
-    hintCacheNetDestroy(&parentOutgoingA[ii]);
-  }
-  xfree(parentOutgoingA);
-  parentOutgoingA = NULL;
-  hintCacheNetDestroy(neighborsOutgoing);
-  xfree(neighborsOutgoing);
-  neighborsOutgoing = NULL;
+    for (ii = 0; ii < hintCacheHier_NChildrenQs(); ii++) {
+	hintCacheNetDestroy(&childrenOutgoingA[ii]);
+    }
+    xfree(childrenOutgoingA);
+    childrenOutgoingA = NULL;
+    for (ii = 0; ii < hintCacheHier_NParentQs(); ii++) {
+	hintCacheNetDestroy(&parentOutgoingA[ii]);
+    }
+    xfree(parentOutgoingA);
+    parentOutgoingA = NULL;
+    hintCacheNetDestroy(neighborsOutgoing);
+    xfree(neighborsOutgoing);
+    neighborsOutgoing = NULL;
 #endif
 
-  hintCacheHierDestroy();
+    hintCacheHierDestroy();
 
-  hintCacheDiskClose(hcDisk);
-  xfree(hcDisk);
-  hcDisk = NULL;
+    hintCacheDiskClose(hcDisk);
+    xfree(hcDisk);
+    hcDisk = NULL;
 }
 
 /*
@@ -182,14 +186,14 @@
  *
  *------------------------------------------------------------------
  */
-void 
+void
 hintCacheCreate(void)
 {
-  if (access(Config.Hints.cachefile, R_OK|W_OK) == -1)
-      hintCacheDiskCreateFile(Config.Hints.cachefile, Config.Hints.size,
-			Config.Hints.assoc);
-  
-  hintCacheInit();
+    if (access(Config.Hints.cache_file, R_OK | W_OK) == -1)
+	hintCacheDiskCreateFile(Config.Hints.cache_file, Config.Hints.size,
+	    Config.Hints.assoc);
+
+    hintCacheInit();
 }
 
 /*
@@ -210,21 +214,23 @@
  *
  *------------------------------------------------------------------
  */
-void 
-hintCacheInformLocalCopy(char *url, StoreEntry *entry)
+void
+hintCacheInformLocalCopy(StoreEntry * entry)
 {
+    char *url = entry->mem_obj->url;
     struct sockaddr_in *me;
     HintCacheEntry myentry;
-    URLKey key;
+    URLKey *key;
     HintCacheUpdate update;
-    
-    debug(HINT_CACHE_DEBUG, 5) ("hintCacheinformLocalCopy: got %s\n", url);
-    
+
+    debug(HINT_CACHE_DEBUG, 5) ("hintCacheinformLocalCopy: got %s\n",
+				url);
+
     if (!HINT_CACHE_ACTIVE()) {
 	/* Hint cache is inoperative.  Nothing to do. */
 	return;
     }
-  
+
     if (strstr(url, "//updates"))
 	/* Routes handle their own updates */
 	return;
@@ -232,45 +238,46 @@
     me = &Config.Sockaddr.http->s;
 
     /* Prepare data structures */
-    URLKey_Init(&key, url);
-    hintCacheEntryInit(&myentry, key, me, entry->lastmod);
+    key = HINT_CACHE_KEY(entry);
+    hintCacheEntryInit(&myentry, *key, me, entry->lastmod);
     hintCacheUpdateInit(&update, HC_InformToParent, &myentry, 0);
-    
+
     /*
      * Update local and remote hint caches.
      */
-    hintCacheProp_HandleInformToParent(&update, me, 1);
+    hintCachePropHandleInformToParent(&update, me, 1);
     update.action = HC_InformToChild;
-    hintCacheProp_HandleInformToChild(&update, me, 1);
+    hintCachePropHandleInformToChild(&update, me, 1);
 }
- 
-void 
-hintCacheInvalLocalCopy(StoreEntry *entry)
+
+void
+hintCacheInvalLocalCopy(StoreEntry * entry)
 {
     struct sockaddr_in *me;
     HintCacheEntry myentry;
     HintCacheUpdate update;
-    
+
     if (!HINT_CACHE_ACTIVE()) {
 	/* Hint cache is inoperative.  Nothing to do. */
 	return;
     }
-  
+
     me = &Config.Sockaddr.http->s;
-    
+
     /* Prepare data structures */
-    hintCacheEntryInit(&myentry, entry->key, me, entry->lastmod);
-    hintCacheUpdateInit(&update, HC_InvalToParent, &myentry, 0); 
-    
+    hintCacheEntryInit(&myentry, *HINT_CACHE_KEY(entry),
+		       me, entry->lastmod);
+    hintCacheUpdateInit(&update, HC_InvalToParent, &myentry, 0);
+
     /*
      * Update local and remote hint caches.
      */
     hintCacheHandleInvalToParent(&update, me, 1);
     update.action = HC_InvalToChild;
     hintCachePropHandleInvalToChild(&update, me, 1);
-    
+
     debug(HINT_CACHE_DEBUG, 5) ("hintCacheinvalLocalCopy: lost 0x%qx\n",
-				entry->key.key);
+				((URLKey *) &entry->hchash.key)->key);
 }
 
 
@@ -296,45 +303,44 @@
  *----------------------------------------------3.24.1998-----------
  */
 struct sockaddr_in *
-hintCacheFindNearest(char *url, struct sockaddr_in *saddr)
+hintCacheFindNearest(StoreEntry *entry, struct sockaddr_in *saddr)
 {
-  const struct sockaddr_in *me;
-  URLKey urlKey;
-  HintCacheEntry nearest;
-  int found;
-
-  if (!HINT_CACHE_ACTIVE()) {
-      /* Hint cache is inoperative.  Nothing to do. */
-      return(NULL);
-  }
-  
-  URLKey_Init(&urlKey, url);
-  found = hintCacheDiskFindNearest(hcDisk, urlKey, &nearest);
-  if(!found)
-    return NULL;
-
-  saddr->sin_family = AF_INET;
-  saddr->sin_port = nearest.port;
-  saddr->sin_addr = nearest.ipaddr;
-  
-  /* Never return ourselves. */
-  me = &Config.Sockaddr.http->s;
-  if (saddr->sin_port == me->sin_port) {
-      if (saddr->sin_addr.s_addr == me->sin_addr.s_addr)
-	  return NULL;
-      if (saddr->sin_addr.s_addr ==  0x7f000000)
-	  return NULL;
-  }
-
-#if 0 /* Fixed? */
-  /* XXX - shouldn't be needed, but is - noted in BUGS */
-  /* Swap bytes to host format. */
-  saddr->sin_addr.s_addr = ntohl(saddr->sin_addr.s_addr);
-  saddr->sin_port = ntohs(saddr->sin_port);
+    const struct sockaddr_in *me;
+    URLKey *urlKey;
+    HintCacheEntry nearest;
+    int found;
+
+    if (!HINT_CACHE_ACTIVE()) {
+	/* Hint cache is inoperative.  Nothing to do. */
+	return (NULL);
+    }
+
+    urlKey = HINT_CACHE_KEY(entry);
+    found = hintCacheDiskFindNearest(hcDisk, *urlKey, &nearest);
+    if (!found)
+	return NULL;
+
+    saddr->sin_family = AF_INET;
+    saddr->sin_port = nearest.port;
+    saddr->sin_addr = nearest.ipaddr;
+
+    /* Never return ourselves. */
+    me = &Config.Sockaddr.http->s;
+    if (saddr->sin_port == me->sin_port) {
+	if (saddr->sin_addr.s_addr == me->sin_addr.s_addr)
+	    return NULL;
+	if (saddr->sin_addr.s_addr == 0x7f000000)
+	    return NULL;
+    }
+#if 0				/* Fixed? */
+    /* XXX - shouldn't be needed, but is - noted in BUGS */
+    /* Swap bytes to host format. */
+    saddr->sin_addr.s_addr = ntohl(saddr->sin_addr.s_addr);
+    saddr->sin_port = ntohs(saddr->sin_port);
 #endif
-  debug(HINT_CACHE_DEBUG, 5) ("hintCachefindNearest: %s is at <%s,%d>\n",
-	 url, inet_ntoa(saddr->sin_addr), saddr->sin_port);
-  return(saddr);
+    debug(HINT_CACHE_DEBUG, 5) ("hintCachefindNearest: %s is at <%s,%d>\n",
+	entry->mem_obj->url, inet_ntoa(saddr->sin_addr), saddr->sin_port);
+    return (saddr);
 }
 
 
@@ -357,11 +363,11 @@
  *
  *------------------------------------------------------------------
  */
-static void 
+static void
 hintCacheTimer(void *junk)
 {
     struct sockaddr_in sin;
-#ifdef USE_DYNAMIC_HIERARCHY
+#if USE_DYNAMIC_HIERARCHY
     struct sockaddr_in *childSinA = NULL;
     static int nextjoin = 0;
     int nchildren, ichild;
@@ -373,42 +379,46 @@
 
     /* Reload timer */
     eventAdd("hint timer", hintCacheTimer, NULL,
-	     (double) (squid_random() % Config.Hints.intvl), 1);
-  
-#ifdef USE_DYNAMIC_HIERARCHY
+	(double) (squid_random() % Config.Hints.intvl), 1);
+
+#if USE_DYNAMIC_HIERARCHY
     /* Process peers */
     /* Send enqueued updates */
-    if(parentOutgoingA != NULL){
-	for(ii = 0; ii < hintCacheHier_NParentQs(); ii++){
-	    if(hintCacheNetBytesReady(&parentOutgoingA[ii]) > sizeof(HintCacheNetHeader)){
+    if (parentOutgoingA != NULL) {
+	for (ii = 0; ii < hintCacheHier_NParentQs(); ii++) {
+	    if (hintCacheNetBytesReady(&parentOutgoingA[ii]) >
+		sizeof(HintCacheNetHeader)) {
 		hintCacheNetComplete(&parentOutgoingA[ii]);
 		error = hintCacheHierGetParentAddr(ii, &sin);
 		debug(HINT_CACHE_DEBUG, 6)
-		      ("Sending %d bytes from parentOutgoing[%d] to %s %s\n",
-		      hintCacheNetbytesReady(&parentOutgoingA[ii]), ii, 
-		      inet_ntoa(sin.sin_addr),
-		      error?"ERROR":"");
-		if(!error){
+		    ("Sending %d bytes from parentOutgoing[%d] to %s %s\n",
+		    hintCacheNetbytesReady(&parentOutgoingA[ii]), ii,
+		    inet_ntoa(sin.sin_addr), error ? "ERROR" : "");
+		if (!error) {
 		    hintCacheNetSendTo(&parentOutgoingA[ii], &sin);
 		}
 		hintCacheNetDone(&parentOutgoingA[ii]);
 	    }
 	}
     }
-    if (childrenOutgoingA != NULL){
-	for(ii = 0; ii < hintCacheHierNChildrenQs(); ii++){
-	    if(hintCacheNet_bytesReady(&childrenOutgoingA[ii]) > sizeof(HintCacheNetHeader)){
+    if (childrenOutgoingA != NULL) {
+	for (ii = 0; ii < hintCacheHierNChildrenQs(); ii++) {
+	    if (hintCacheNet_bytesReady(&childrenOutgoingA[ii]) >
+		sizeof(HintCacheNetHeader)) {
 		hintCacheNetComplete(&childrenOutgoingA[ii]);
 		nchildren = hintCacheHierGetChildAddrs(ii, &childSinA);
 		debug(HINT_CACHE_DEBUG, 6)
-		      ("Sending %d bytes to %d children from childrenOutgoing[%d]:",
-		      hintCacheNetBytesReady(&childrenOutgoingA[ii]), nchildren, ii);
-		
-		for(ichild = 0; ichild < nchildren; ichild++){
-		    debug(HINT_CACHE_DEBUG, 8) (" %s ", inet_ntoa(childSinA[ichild].sin_addr));
-		    hintCacheNetSendTo(&childrenOutgoingA[ii], &childSinA[ichild]);
+		    ("Sending %d bytes to %d children from childrenOutgoing[%d]:",
+		    hintCacheNetBytesReady(&childrenOutgoingA[ii]), nchildren,
+		    ii);
+
+		for (ichild = 0; ichild < nchildren; ichild++) {
+		    debug(HINT_CACHE_DEBUG, 8) (" %s ",
+			inet_ntoa(childSinA[ichild].sin_addr));
+		    hintCacheNetSendTo(&childrenOutgoingA[ii],
+			&childSinA[ichild]);
 		}
-		
+
 		hintCacheNetDone(&childrenOutgoingA[ii]);
 		xfree(childSinA);
 	    }
@@ -427,24 +437,24 @@
 #endif /* USE_DYNAMIC_HIERARCHY */
 
 
-#ifdef USE_DYNAMIC_HIERARCHY
+#if USE_DYNAMIC_HIERARCHY
     /*
      * Send out Joins once every few hours.
      */
-    if(hintCacheNodelistMyStatus() == HC_Join){
+    if (hintCacheNodelistMyStatus() == HC_Join) {
 	if (squid_curtime >= nextjoin) {
 	    hintCacheNodelistLocalJoin();
-	    nextjoin = squid_curtime + (squid_random() % Config.Hints.joinintvl);
+	    nextjoin =
+		squid_curtime + (squid_random() % Config.Hints.join_intvl);
 	}
     }
 #endif
 
 #ifdef DOTEST
-    if(0){  /* XXX */
-	if(!hintCacheHierSelfTestDone){
+    if (0) {			/* XXX */
+	if (!hintCacheHierSelfTestDone) {
 	    hintCacheHierTestNetwork();
 	}
     }
 #endif
 }
-
